# -*- coding: utf-8 -*-
import logging
import mv_common

def read_release(stype):
    if stype == "LinHES":
        rfile = "/etc/LinHES-release"
    else:
        rfile = "/etc/MythVantage-release"

    try:
        f= open(rfile,'r')
        releasename = f.readlines()[0]
        f.close()
    except:
        logging.debug("    Couldn't open %s",rfile)
        releasename = "unknown"

    return releasename


def setup_smolt_type(SystemType,Remotetype,RunFrontend,mythhome,stype):
    if  mv_common.read_config(mv_common.module_config,"smolt")  == False  :
        logging.info("____Skipping of smolt, config disabled____")
        return
    logging.debug("____Start of setup_smolt_type____")
    releasename = read_release(stype)

    if SystemType == "Standalone":
        smoltsystem = 6
        MVRELEASE="%s (Standalone)" %releasename
    elif SystemType == "Master_backend":
        if RunFrontend == "1":
            smoltsystem = 2
            MVRELEASE="%s (MBE with Frontend)" %releasename
        else:
            smoltsystem=1
            MVRELEASE="%s (MBE)" %releasename
    elif SystemType == "Slave_backend":
        if RunFrontend == "1" :
            smoltsystem = 4
            MVRELEASE="%s (SLAVE  with Frontend)" %releasename
        else:
            smoltsystem = 5
            MVRELEASE="%s (SLAVE)" %releasename
    elif SystemType == "Frontend_only":
        smoltsystem = 3
        MVRELEASE="%s ( Frontend only)" %releasename

    logging.debug("    smolt type is %s : %s", MVRELEASE,smoltsystem)
    smoltfile = mythhome+"/.mythtv/smolt.info"
    cmd = ''' echo  "%s" > /etc/os_myth_release ''' %MVRELEASE
    mv_common.runcmd(cmd)

    cmd = '''echo "systemtype=%s" > %s''' %(smoltsystem,smoltfile)
    mv_common.runcmd(cmd)

    cmd = '''echo "remote=%s" >> %s ''' %(Remotetype,smoltfile)
    mv_common.runcmd(cmd)

    logging.debug("__End of setup_smolt_type")

